"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.makeCheckAndSetSequenceNumberIx = exports.makeInitSequenceEnforcerAccountIx = exports.seqEnforcerProgramIds = void 0;
const anchor_1 = require("@project-serum/anchor");
const web3_js_1 = require("@solana/web3.js");
const crypto_1 = require("crypto");
exports.seqEnforcerProgramIds = {
    devnet: new web3_js_1.PublicKey('FBngRHN4s5cmHagqy3Zd6xcK3zPJBeX5DixtHFbBhyCn'),
    testnet: new web3_js_1.PublicKey('FThcgpaJM8WiEbK5rw3i31Ptb8Hm4rQ27TrhfzeR1uUy'),
    'mainnet-beta': new web3_js_1.PublicKey('GDDMwNyyx8uB6zrqwBFHjLLG3TBYk2F8Az4yrQC5RzMp'),
};
function makeInitSequenceEnforcerAccountIx(account, ownerPk, bump, sym, cluster) {
    const keys = [
        { isSigner: false, isWritable: true, pubkey: account },
        { isSigner: true, isWritable: true, pubkey: ownerPk },
        { isSigner: false, isWritable: false, pubkey: web3_js_1.SystemProgram.programId },
    ];
    const variant = (0, crypto_1.createHash)('sha256')
        .update('global:initialize')
        .digest()
        .slice(0, 8);
    const bumpData = new anchor_1.BN(bump).toBuffer('le', 1);
    const strLen = new anchor_1.BN(sym.length).toBuffer('le', 4);
    const symEncoded = Buffer.from(sym);
    const data = Buffer.concat([variant, bumpData, strLen, symEncoded]);
    return new web3_js_1.TransactionInstruction({
        keys,
        data,
        programId: exports.seqEnforcerProgramIds[cluster],
    });
}
exports.makeInitSequenceEnforcerAccountIx = makeInitSequenceEnforcerAccountIx;
function makeCheckAndSetSequenceNumberIx(sequenceAccount, ownerPk, seqNum, cluster) {
    const keys = [
        { isSigner: false, isWritable: true, pubkey: sequenceAccount },
        { isSigner: true, isWritable: false, pubkey: ownerPk },
    ];
    const variant = (0, crypto_1.createHash)('sha256')
        .update('global:check_and_set_sequence_number')
        .digest()
        .slice(0, 8);
    const seqNumBuffer = new anchor_1.BN(seqNum).toBuffer('le', 8);
    const data = Buffer.concat([variant, seqNumBuffer]);
    return new web3_js_1.TransactionInstruction({
        keys,
        data,
        programId: exports.seqEnforcerProgramIds[cluster],
    });
}
exports.makeCheckAndSetSequenceNumberIx = makeCheckAndSetSequenceNumberIx;
//# sourceMappingURL=sequence-enforcer-util.js.map